﻿Type=Class
Version=2.52
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private animator As SpriteAnimator
	Private bd As BitmapData
	Private game As GameManager
	Public delete As Boolean
End Sub

Public Sub Initialize (vBD As BitmapData, vAnimator As SpriteAnimator, vGame As GameManager, _ 
		x As Int, y As Int, size As Int)
	animator = vAnimator
	animator.width = size
	animator.height = animator.width
	bd = vBD
	bd.DestRect.Initialize(x, y, x + animator.width, y + animator.height)
	animator.vx = Rnd(0.1%x, 0.5%x)
	animator.vy = Rnd(0.1%y, 0.5%y)
	If Rnd(1, 3) = 2 Then animator.vx = -animator.vx
	If Rnd(1, 3) = 2 Then animator.vy = -animator.vy
	game = vGame
End Sub

Public Sub Tick
	'the animator will move the asteroid and animate it.
	animator.Tick(bd)
End Sub

Public Sub RemoveFromGameView
	bd.delete = True
End Sub

Public Sub Explode
	RemoveFromGameView
	delete = True 'this will cause GameManager to remove the asteroid from the list.
	'If this is a large asteroid then we add two new smaller asteroids instead of this one
	If animator.width > 70 * GameUtils.scale Then
'		game.AddAsteroid(bd.DestRect.Left, bd.DestRect.Top, animator.width / 2)
'		game.AddAsteroid(bd.DestRect.Left, bd.DestRect.Top, animator.width / 2)
	End If
End Sub

'This method is called by CollisionDetector to get the asteroid location and size
'CallSub methods can only return primitive types, so we pass an array with a single element.
Public Sub GetRect(outRect() As Rect)
	outRect(0) = bd.DestRect
End Sub