﻿Type=Class
Version=2.52
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public gv As GameView
	Public pad As GamePad
	Private mainTimer As Timer
	Private fps As Float
	fps = 30 'this value is not really important. It is just an approximate used when starting t
	Private ldoggieTime As Long
	Private lblFPS As Label
	Private lblAngle As Label
	Public Dogs As List
	Private DogsBitmaps(,) As BitmapData
	Public leroyBitmaps(,) As BitmapData
	Public MyLeroy As Leroy
	Public streetBackground As BitmapData
'	Public missileBitmap() As Bitmap
'	Public missileRect(2) As Rect
'	Public missiles As List
	Private sounds As SoundPool
	Public shotSoundId, breakSoundId, crashSoundId As Int
		Public backgroundScale As Int : backgroundScale = 1
End Sub

Public Sub Initialize (vGV As GameView, vPad As GamePad, vlblFPS As Label, vlblAngle As Label)
	GameUtils.init
	gv = vGV
	pad = vPad
	lblFPS = vlblFPS
	lblAngle = vlblAngle
	mainTimer.Initialize("MainTimer", 15)
	DogsBitmaps = GameUtils.LoadSpritesFromSheet(LoadBitmap(File.DirAssets, "dog_spritesheet.png"), 6, 2)
	Dogs.Initialize
'	missileBitmap = Array As Bitmap(LoadBitmap(File.DirAssets, "missile1.png"), _ 
'		LoadBitmap(File.DirAssets, "missile2.png"))
	streetBackground = CreateBackground
	gv.BitmapsData.Add(streetBackground)
	

	
	Dim bd As BitmapData
'	MyLeroy.Initialize
	
	leroyBitmaps = GameUtils.LoadSpritesFromSheet(LoadBitmap(File.DirAssets, "leroy_spritesheet.png"), 6, 1)
AddLeroy
'	gv.BitmapsData.Add(bd)
	
'	missiles.Initialize
	'sounds are loaded to a SoundPool
	sounds.Initialize(4)
	shotSoundId = sounds.Load(File.DirAssets, "shotgun.mp3")
	breakSoundId = sounds.Load(File.DirAssets, "break.mp3")
	crashSoundId = sounds.Load(File.DirAssets, "crash.mp3")
	
	'add the game pad 
	pad.Initialize(gv)
	Dim length, rightPadding, leftPadding, bottomPadding As Int
	length = 100 * GameUtils.scale 'also the panel's height
	rightPadding = 50 * GameUtils.scale
	leftPadding = 20 * GameUtils.scale
	bottomPadding = 20 * GameUtils.scale
	pad.AddToGameView (gv, leftPadding, 100%y - bottomPadding - length, _
		100%x - rightPadding - leftPadding, length)
	
	StartGame
End Sub

Private Sub StartGame
	'Clear the previous remaining dogs.
	For i = 0 To Dogs.Size - 1
		Dim doggie As Dog
		doggie = Dogs.Get(i)
		doggie.RemoveFromGameView 'This method will remove the Dog from the GameView
	Next
	Dogs.Clear
	'Create 4 new Dogs
	For i = 1 To 4
		AddDog (Rnd(1%x, 99%x), Rnd(1%y, 99%y), _
			Rnd(50 * GameUtils.scale, 150 * GameUtils.scale))
	Next
	
'MyLeroy.ResetLeroy
End Sub

Public Sub AddLeroy
	Dim animator As SpriteAnimator
	Dim rects(6) As Rect
	Dim bitmaps(6) As Bitmap
	Dim row As Int
	row = 0
	'The Leroy sprite sheet includes 1 row of sprites.
	For i = 0 To 5
		rects(i) = leroyBitmaps(i, row).SrcRect
		bitmaps(i) = leroyBitmaps(i, row).Bitmap
	Next
	
	animator.Initialize
	Dim bd As BitmapData
	animator.SetFrames(bd, rects, bitmaps) 'sets the frames that will be animated
	animator.AnimationInterval = 10

	MyLeroy.Initialize(bd, animator, Me, 50%x, 50%y, 250)

	gv.BitmapsData.Add(bd) 'add Leroy to the GameView (so it will be redrawn every time).

End Sub

Public Sub AddDog (x As Int, y As Int, size As Int)
	Dim animator As SpriteAnimator
	Dim rects(6) As Rect
	Dim bitmaps(6) As Bitmap
	Dim row As Int
	row = Rnd(0, 2)
	'The Dogs sprite sheet includes 4 rows of sprites.
	'One of the rows is randomly selected.
	For i = 0 To 5
		rects(i) = DogsBitmaps(i, row).SrcRect
		bitmaps(i) = DogsBitmaps(i, row).Bitmap
	Next
	
	animator.Initialize
	Dim bd As BitmapData
	animator.SetFrames(bd, rects, bitmaps) 'sets the frames that will be animated
	animator.AnimationInterval = 10
	Dim doggie As Dog
	doggie.Initialize(bd, animator, Me, x, y, 125)
	Dogs.Add(doggie) 'add the Dog to the Dogs list.
	gv.BitmapsData.Add(bd) 'add the Dog to the GameView (so it will be redrawn every time).
End Sub

Public Sub StartTimer
	mainTimer.Enabled = True
End Sub

Public Sub StopTimer
	mainTimer.Enabled = False
End Sub

Private Sub mainTimer_Tick
	'calculate the frames per second
	fps = (1000 / Max(10, (DateTime.Now - ldoggieTime)) + 20 * fps) / 21
	lblFPS.Text = NumberFormat(fps, 0, 0)
	ldoggieTime = DateTime.Now
	
	lblAngle.Text = MyLeroy.leroyAngle
	
	Dim doggie As Dog
	Dim i As Int
	i = 0
	'if there are no more Dogs then the game is completed (the player has destroyed all of them).
	If Dogs.Size = 0 Then
		Msgbox("Well done!", "")
		StartGame
		Return
	End If
	'go over all the Dogs and call their tick method.
	Do While i < Dogs.Size
		doggie = Dogs.Get(i)
		'if the Dog delete flag is on then we remove it from the list.
		If doggie.delete Then
			Dogs.RemoveAt(i)
		Else
			doggie.Tick
			i = i + 1
		End If
	Loop

	'call the ship tick method.
MyLeroy.Tick
	'check whether the ship is in the crash state.
'	If MyLeroy.state = MyLeroy.STATE_CRASHED Then
'		Msgbox("Try again...", "")
'		StartGame
'	End If
	'mark the GameView as "dirty". This will cause it to redraw itself.
	gv.Invalidate
End Sub

Public Sub PlaySound(sound As Int, volume As Float)
	sounds.Play(sound, volume, volume, 0, 0, 1)
End Sub

'Load street into background
Private Sub CreateBackground As BitmapData
	'The background is created manually with a bitmap and canvas.
	Dim bd As BitmapData
	
	bd.Bitmap.InitializeMutable(100%x / backgroundScale, 70%y / backgroundScale) 'create a wide image
	bd.Bitmap = LoadBitmap(File.DirAssets, "streetmap.png")
	bd.srcRect.Initialize(0, 50dip, 100%x / backgroundScale, 70%y / backgroundScale)
	bd.destRect.Initialize(0, 50dip, 100%x, 70%y)
	Return bd
End Sub



