﻿Type=Class
Version=2.52
@EndOfDesignText@
'version: 1.10
Sub Class_Globals
	Private g As Gestures
	Private width, height As Int
	Private pnlRect As Rect
	Public NONE, LEFT, RIGHT, UP, DOWN
	NONE = 0
	LEFT = 1
	RIGHT = 2
	UP = 3
	DOWN = 4
	Type joystick(x As Float, y As Float, zeroX As Float, zeroY As Float, color As Int, bd As BitmapData)
	Dim jleft, jright As joystick
	Private radius As Int
	Private TouchMap As Map
	Public currentAngle As Int
	Type Point(Id As Int, prevX As Int, prevY As Int, Color As Int)
End Sub

Public Sub Initialize (parent As View)
	g.SetOnTouchListener(parent, "pnl_multitouch")
	jleft.Initialize
	jleft.color = Colors.Red
'	jright.Initialize
'	jright.color = Colors.Blue
	TouchMap.Initialize
End Sub

Public Sub AddToGameView(gv As GameView, vLeft As Int, vTop As Int, vWidth As Int, vHeight As Int)
	width = vWidth
	height = vHeight
	pnlRect.Initialize(vLeft, vTop, vWidth, vHeight)

	'add stick Background
	Dim stickBKG As Bitmap
	stickBKG = LoadBitmap(File.DirAssets, "scopestick.png")
	Dim bd1 As BitmapData
	bd1.Bitmap = stickBKG
	bd1.DestRect.Initialize(vLeft, vTop, vLeft + vHeight, vTop + vHeight)

	gv.BitmapsData.Add(bd1)

	radius = height / 8
	jleft.bd.Bitmap = CreateBitmap(jleft.color)
	jleft.bd.DestRect.Initialize(0, 0, 0,0)
	gv.BitmapsData.Add(jleft.bd)	

	jleft.zeroX = height / 2
	jleft.zeroY = height / 2

	MoveJoystick(jleft.zeroX, jleft.zeroY, jleft)

End Sub

Private Sub CreateBitmap(color As Int) As Bitmap
	Dim b As Bitmap
	b.InitializeMutable(radius * 2, radius * 2)
	Dim cvs As Canvas
	cvs.Initialize2(b)
	cvs.DrawCircle(radius, radius, radius, color, True, 0)
	Return b
End Sub

Private Sub pnl_multitouch(View As Object, pointerID As Int, action As Int, x As Float, y As Float) As Boolean
	Dim p As Point
	
	Dim cX, cY As Int
	Dim fingerDistance As Int
	cX = 360
	cY = 640
	
	Select action
		Case g.ACTION_DOWN, g.ACTION_POINTER_DOWN
			'New Point is assigned to the new touch
			p.Id = pointerID
			p.Color = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
			TouchMap.Put(pointerID, p)
		Case g.ACTION_POINTER_UP
			TouchMap.Remove(pointerID)
		Case g.ACTION_UP
			'This is the end of this gesture
			TouchMap.Clear
	End Select
	'Clear the previous text
'Canvas.DrawRect(TextRect, Colors.Transparent, True, 0)
	Dim px, py As Int
	For i = 0 To TouchMap.Size - 1
		p = TouchMap.GetValueAt(i)
		px = g.GetX(p.id)
		py = g.GetY(p.id)
		
		fingerDistance = Sqrt(Power((cX-px),2) + Power((cY-py), 2))
		currentAngle = ASinD(((py-cY)/fingerDistance))' * (180 / cPI)
		
		If px > cX Then 
			currentAngle = 270 + currentAngle 
		Else
			If py < cY Then 
				currentAngle = 90 + Abs(currentAngle)
			Else
				currentAngle = 90 - currentAngle 
			End If
		End If
		
'		Dim s As String
'		s = currentAngle 'p.Id & ": " & px & " x " & py
'		Canvas.DrawText(s, 10dip, 20dip + i * RowHeight, Typeface.DEFAULT, TextSize, p.Color, "LEFT")
'		If p.prevX > 0 AND p.prevY > 0 Then
'			Canvas.DrawLine(p.prevX, p.prevY, px, py, p.Color, 5dip)
'		End If
		p.prevX = px
		p.prevY = py
	Next
	Return True
End Sub

Private Sub MoveJoystick(x As Float, y As Float, j As joystick)
	Dim valuex, valuey As Float
	valuex = x - j.zeroX
	valuey = y - j.zeroY
	If Abs(valuex) > Abs(valuey) Then y = j.zeroY Else x = j.zeroX
	j.x = x
	j.y = y
	j.bd.DestRect.LEFT = j.x - radius + pnlRect.LEFT
	j.bd.DestRect.Top = j.y - radius + pnlRect.Top
	j.bd.DestRect.RIGHT = j.bd.DestRect.LEFT + 2 * radius
	j.bd.DestRect.Bottom = j.bd.DestRect.Top + 2 * radius
End Sub

Public Sub GetLeftValue As Int
	Return GetValue(jleft)
End Sub


Private Sub GetValue(j As joystick) As Int
	If Power(j.x - j.zeroX, 2) + Power(j.y - j.zeroY, 2) < Power(height / 6, 2) Then
		Return NONE
	Else If j.x < j.zeroX Then 
		Return LEFT
	Else If j.x > j.zeroX Then
		Return RIGHT
	Else If j.y > j.zeroY Then
		Return DOWN
	Else If j.y < j.zeroY Then
		Return UP
	End If
End Sub