﻿Type=Class
Version=2.52
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private animator As SpriteAnimator
	Private leroyBd As BitmapData
	Private game As GameManager
	Private MAX_SPEED As Int
	MAX_SPEED = 100 * GameUtils.scale
	Private speed As Float
	Private leroyStillBmp, leroyForwardBmp, leroyBackwardBmp As Bitmap
	Private currentBmp As Bitmap
	Private leroyRect As Rect
	Private ticks, lastFire, fireInterval, explodeStart As Int
	fireInterval = 20
	Private gracePeriod As Int : gracePeriod = 180
	Private missileSpeed As Int
	missileSpeed = 5 * GameUtils.scale
	Private collision As CollisionDetector
	Private crashBitmaps(,) As BitmapData
	Private leroyBitmaps(,) As BitmapData
	Public state As Int
	Public STATE_NORMAL, STATE_EXPLODING, STATE_CRASHED As Int
	STATE_NORMAL = 0 : STATE_EXPLODING = 1: STATE_CRASHED = 2
	Private bd As BitmapData
	
	Private shipBd As BitmapData
	Private shipBmp, shipForwardBmp, shipBackwardBmp As Bitmap
	
	Private lblAngle As Label
	Public leroyAngle As Int
	
End Sub

Public Sub Initialize (vBD As BitmapData, vAnimator As SpriteAnimator, vGame As GameManager, _ 
		x As Int, y As Int, size As Int)
		
'lblAngle = Main.lblAngle


'	animator.Initialize
'	leroyBd = vBD
'	leroyStillBmp = LoadBitmap(File.DirAssets, "leroy_still.png")
'	
'	animator.width = 30 * GameUtils.scale 'set the sprite width and height
'	animator.height = 45 * GameUtils.scale
'	Dim x, y As Int
'	x = 50%x - animator.width / 2 'start in the middle of the screen
'	y = 50%y - animator.height / 2
'	leroyBd.DestRect.Initialize(x, y , x + animator.width, y + animator.height)	
	
	
	
	animator = vAnimator
	animator.width = size
	animator.height = animator.width
	leroyBd = vBD
	leroyBd.DestRect.Initialize(x, y, x + animator.width, y + animator.height)

	game = vGame
	
	'initialize the Leroy's collistion detector. It will detect collisions between Leroy and the Dogs.
	'passing a SafeZone value of 10 * GameUtils.scale makes the Dogs a bit less harmful.
	collision.Initialize(leroyBd.DestRect, game.Dogs, 10, 10 * GameUtils.scale)
	'load the bitmaps that will be used when Leroy collides with a Dog.
	crashBitmaps = GameUtils.LoadSpritesFromSheet(LoadBitmap(File.DirAssets, "crash.png"), 7, 1)
End Sub

Public Sub ResetLeroy
	Dim tmpRect As Rect
	tmpRect = game.leroyBitmaps(0,0).SrcRect
	ticks = 0
	state = STATE_NORMAL
	lastFire = -100
	animator.AnimationInterval = 1
	'note that the ship is drawn from a single frame.
	'leroyRect is never initialized so GameView draws the complete bitmap.
	animator.SetFrames(leroyBd, Array As Rect(tmpRect), Array As Bitmap(leroyStillBmp))
End Sub

Public Sub Tick
	ticks = ticks + 1
	If state = STATE_NORMAL Then
		'check the left joystick and change the rotation and speed
		Dim dx, dy, vx, vy As Int
		Dim tmpRect As Rect
		tmpRect = game.leroyBitmaps(0,0).SrcRect

		Select game.pad.GetLeftValue
			Case game.pad.LEFT
				leroyBd.Rotate = leroyBd.Rotate - 2
				vx = vx - 4
			Case game.pad.RIGHT
				leroyBd.Rotate = leroyBd.Rotate + 2
				vx = vx + 4
			Case game.pad.UP		
				vy = vy - 4
			Case game.pad.DOWN
				vy = vy + 4
			Case game.pad.NONE

					speed = 0
'	animator.SetFrames(leroyBd, Array As Rect(leroyRect), Array As Bitmap(leroyStillBmp))
	animator.SetFrames(leroyBd, Array As Rect(tmpRect), Array As Bitmap(leroyBd.Bitmap))
		End Select
		
		'set the ship speed
		If leroyBd.DestRect.Right > 99%x Then
			vx = -1 * Abs(vx)
		Else If leroyBd.DestRect.Left < 1%x Then
			vx = Abs(vx)
		End If
		If leroyBd.DestRect.Bottom > 69%y Then
			vy = -1 * Abs(vy)
			game.streetBackground.SrcRect.top = (game.streetBackground.SrcRect.top +  4dip) Mod (game.streetBackground.Bitmap.Height - 100%y / game.backgroundScale)
			game.streetBackground.SrcRect.Bottom = game.streetBackground.SrcRect.top + 100%y / game.backgroundScale
		Else If leroyBd.DestRect.Top < 11%y Then
			vy = Abs(vy)
			game.streetBackground.SrcRect.top = (game.streetBackground.SrcRect.top -4dip) Mod (game.streetBackground.Bitmap.Height - 100%y / game.backgroundScale)
			game.streetBackground.SrcRect.Bottom = game.streetBackground.SrcRect.top + 100%y / game.backgroundScale
		End If
		
	leroyBd.DestRect.Left = leroyBd.DestRect.Left + vx
	leroyBd.DestRect.Top = leroyBd.DestRect.Top + vy
	leroyBd.DestRect.Right = leroyBd.DestRect.Left + 250
	leroyBd.DestRect.Bottom = leroyBd.DestRect.Top + 250
		
		
		animator.vx = speed * SinD(leroyBd.Rotate)
		animator.vy = -speed * CosD(leroyBd.Rotate)

		'Calling Collision.Tick actually checks for collisions.
		If collision.Tick <> Null AND ticks > gracePeriod Then
			Crash
		End If
		
	Else If state = STATE_EXPLODING Then
		'STATE_EXPLODING is a two seconds state that shows the ship burning before stopping the game.
		If ticks - explodeStart > 120 Then
			state = STATE_CRASHED
		End If
	End If
	animator.Tick(leroyBd) 'move the ship
	leroyBd.Rotate = game.pad.currentAngle

leroyAngle = leroyBd.Rotate
End Sub

Private Sub Crash
	state = STATE_EXPLODING
	game.PlaySound(game.crashSoundId, 0.3)
	Dim rects(4) As Rect
	Dim bitmaps(4) As Bitmap
	For i = 0 To 3
		rects(i) = crashBitmaps(i, 0).SrcRect
		bitmaps(i) = crashBitmaps(i, 0).Bitmap
	Next
	'Change the ship animation frames.
	animator.SetFrames(leroyBd, rects, bitmaps)
	animator.AnimationInterval = 10
	explodeStart = ticks
End Sub


